// Copyright (c) 2005-2017 Code Synthesis Tools CC
//
// This program was generated by CodeSynthesis XSD, an XML Schema to
// C++ data binding compiler.
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License version 2 as
// published by the Free Software Foundation.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
//
// In addition, as a special exception, Code Synthesis Tools CC gives
// permission to link this program with the Xerces-C++ library (or with
// modified versions of Xerces-C++ that use the same license as Xerces-C++),
// and distribute linked combinations including the two. You must obey
// the GNU General Public License version 2 in all respects for all of
// the code used other than Xerces-C++. If you modify this copy of the
// program, you may extend this exception to your version of the program,
// but you are not obligated to do so. If you do not wish to do so, delete
// this exception statement from your version.
//
// Furthermore, Code Synthesis Tools CC makes a special exception for
// the Free/Libre and Open Source Software (FLOSS) which is described
// in the accompanying FLOSSE file.
//

#ifndef CXX_BUILDDIR_BUILD_BUILD_LIBDIGIDOCPP_3_16_0_ETC_SCHEMA_OPEN_DOCUMENT_MANIFEST_V1_2_HXX
#define CXX_BUILDDIR_BUILD_BUILD_LIBDIGIDOCPP_3_16_0_ETC_SCHEMA_OPEN_DOCUMENT_MANIFEST_V1_2_HXX

#ifndef XSD_CXX11
#define XSD_CXX11
#endif

#ifndef XSD_USE_CHAR
#define XSD_USE_CHAR
#endif

#ifndef XSD_CXX_TREE_USE_CHAR
#define XSD_CXX_TREE_USE_CHAR
#endif

// Begin prologue.
//
//
// End prologue.

#include <xsd/cxx/config.hxx>

#if (XSD_INT_VERSION != 4009911L)
#error XSD runtime version mismatch
#endif

#include <xsd/cxx/pre.hxx>

#include <xsd/cxx/xml/char-utf8.hxx>

#include <xsd/cxx/tree/exceptions.hxx>
#include <xsd/cxx/tree/elements.hxx>
#include <xsd/cxx/tree/types.hxx>

#include <xsd/cxx/xml/error-handler.hxx>

#include <xsd/cxx/xml/dom/auto-ptr.hxx>

#include <xsd/cxx/tree/parsing.hxx>
#include <xsd/cxx/tree/parsing/byte.hxx>
#include <xsd/cxx/tree/parsing/unsigned-byte.hxx>
#include <xsd/cxx/tree/parsing/short.hxx>
#include <xsd/cxx/tree/parsing/unsigned-short.hxx>
#include <xsd/cxx/tree/parsing/int.hxx>
#include <xsd/cxx/tree/parsing/unsigned-int.hxx>
#include <xsd/cxx/tree/parsing/long.hxx>
#include <xsd/cxx/tree/parsing/unsigned-long.hxx>
#include <xsd/cxx/tree/parsing/boolean.hxx>
#include <xsd/cxx/tree/parsing/float.hxx>
#include <xsd/cxx/tree/parsing/double.hxx>
#include <xsd/cxx/tree/parsing/decimal.hxx>

#include <xsd/cxx/xml/dom/serialization-header.hxx>
#include <xsd/cxx/tree/serialization.hxx>
#include <xsd/cxx/tree/serialization/byte.hxx>
#include <xsd/cxx/tree/serialization/unsigned-byte.hxx>
#include <xsd/cxx/tree/serialization/short.hxx>
#include <xsd/cxx/tree/serialization/unsigned-short.hxx>
#include <xsd/cxx/tree/serialization/int.hxx>
#include <xsd/cxx/tree/serialization/unsigned-int.hxx>
#include <xsd/cxx/tree/serialization/long.hxx>
#include <xsd/cxx/tree/serialization/unsigned-long.hxx>
#include <xsd/cxx/tree/serialization/boolean.hxx>
#include <xsd/cxx/tree/serialization/float.hxx>
#include <xsd/cxx/tree/serialization/double.hxx>
#include <xsd/cxx/tree/serialization/decimal.hxx>

namespace xml_schema
{
  // anyType and anySimpleType.
  //
  typedef ::xsd::cxx::tree::type Type;
  typedef ::xsd::cxx::tree::simple_type< char, Type > SimpleType;
  typedef ::xsd::cxx::tree::type Container;

  // 8-bit
  //
  typedef signed char Byte;
  typedef unsigned char UnsignedByte;

  // 16-bit
  //
  typedef short Short;
  typedef unsigned short UnsignedShort;

  // 32-bit
  //
  typedef int Int;
  typedef unsigned int UnsignedInt;

  // 64-bit
  //
  typedef long long Long;
  typedef unsigned long long UnsignedLong;

  // Supposed to be arbitrary-length integral types.
  //
  typedef long long Integer;
  typedef long long NonPositiveInteger;
  typedef unsigned long long NonNegativeInteger;
  typedef unsigned long long PositiveInteger;
  typedef long long NegativeInteger;

  // Boolean.
  //
  typedef bool Boolean;

  // Floating-point types.
  //
  typedef float Float;
  typedef double Double;
  typedef double Decimal;

  // String types.
  //
  typedef ::xsd::cxx::tree::string< char, SimpleType > String;
  typedef ::xsd::cxx::tree::normalized_string< char, String > NormalizedString;
  typedef ::xsd::cxx::tree::token< char, NormalizedString > Token;
  typedef ::xsd::cxx::tree::name< char, Token > Name;
  typedef ::xsd::cxx::tree::nmtoken< char, Token > Nmtoken;
  typedef ::xsd::cxx::tree::nmtokens< char, SimpleType, Nmtoken > Nmtokens;
  typedef ::xsd::cxx::tree::ncname< char, Name > Ncname;
  typedef ::xsd::cxx::tree::language< char, Token > Language;

  // ID/IDREF.
  //
  typedef ::xsd::cxx::tree::id< char, Ncname > Id;
  typedef ::xsd::cxx::tree::idref< char, Ncname, Type > Idref;
  typedef ::xsd::cxx::tree::idrefs< char, SimpleType, Idref > Idrefs;

  // URI.
  //
  typedef ::xsd::cxx::tree::uri< char, SimpleType > Uri;

  // Qualified name.
  //
  typedef ::xsd::cxx::tree::qname< char, SimpleType, Uri, Ncname > Qname;

  // Binary.
  //
  typedef ::xsd::cxx::tree::buffer< char > Buffer;
  typedef ::xsd::cxx::tree::base64_binary< char, SimpleType > Base64Binary;
  typedef ::xsd::cxx::tree::hex_binary< char, SimpleType > HexBinary;

  // Date/time.
  //
  typedef ::xsd::cxx::tree::time_zone TimeZone;
  typedef ::xsd::cxx::tree::date< char, SimpleType > Date;
  typedef ::xsd::cxx::tree::date_time< char, SimpleType > DateTime;
  typedef ::xsd::cxx::tree::duration< char, SimpleType > Duration;
  typedef ::xsd::cxx::tree::gday< char, SimpleType > Gday;
  typedef ::xsd::cxx::tree::gmonth< char, SimpleType > Gmonth;
  typedef ::xsd::cxx::tree::gmonth_day< char, SimpleType > GmonthDay;
  typedef ::xsd::cxx::tree::gyear< char, SimpleType > Gyear;
  typedef ::xsd::cxx::tree::gyear_month< char, SimpleType > GyearMonth;
  typedef ::xsd::cxx::tree::time< char, SimpleType > Time;

  // Entity.
  //
  typedef ::xsd::cxx::tree::entity< char, Ncname > Entity;
  typedef ::xsd::cxx::tree::entities< char, SimpleType, Entity > Entities;

  typedef ::xsd::cxx::tree::content_order ContentOrder;
  // Namespace information and list stream. Used in
  // serialization functions.
  //
  typedef ::xsd::cxx::xml::dom::namespace_info< char > NamespaceInfo;
  typedef ::xsd::cxx::xml::dom::namespace_infomap< char > NamespaceInfomap;
  typedef ::xsd::cxx::tree::list_stream< char > ListStream;
  typedef ::xsd::cxx::tree::as_double< Double > AsDouble;
  typedef ::xsd::cxx::tree::as_decimal< Decimal > AsDecimal;
  typedef ::xsd::cxx::tree::facet Facet;

  // Flags and properties.
  //
  typedef ::xsd::cxx::tree::flags Flags;
  typedef ::xsd::cxx::tree::properties< char > Properties;

  // Parsing/serialization diagnostics.
  //
  typedef ::xsd::cxx::tree::severity Severity;
  typedef ::xsd::cxx::tree::error< char > Error;
  typedef ::xsd::cxx::tree::diagnostics< char > Diagnostics;

  // Exceptions.
  //
  typedef ::xsd::cxx::tree::exception< char > Exception;
  typedef ::xsd::cxx::tree::bounds< char > Bounds;
  typedef ::xsd::cxx::tree::duplicate_id< char > DuplicateId;
  typedef ::xsd::cxx::tree::parsing< char > Parsing;
  typedef ::xsd::cxx::tree::expected_element< char > ExpectedElement;
  typedef ::xsd::cxx::tree::unexpected_element< char > UnexpectedElement;
  typedef ::xsd::cxx::tree::expected_attribute< char > ExpectedAttribute;
  typedef ::xsd::cxx::tree::unexpected_enumerator< char > UnexpectedEnumerator;
  typedef ::xsd::cxx::tree::expected_text_content< char > ExpectedTextContent;
  typedef ::xsd::cxx::tree::no_prefix_mapping< char > NoPrefixMapping;
  typedef ::xsd::cxx::tree::serialization< char > Serialization;

  // Error handler callback interface.
  //
  typedef ::xsd::cxx::xml::error_handler< char > ErrorHandler;

  // DOM interaction.
  //
  namespace dom
  {
    // Automatic pointer for DOMDocument.
    //
    using ::xsd::cxx::xml::dom::unique_ptr;

#ifndef XSD_CXX_TREE_TREE_NODE_KEY__XML_SCHEMA
#define XSD_CXX_TREE_TREE_NODE_KEY__XML_SCHEMA
    // DOM user data key for back pointers to tree nodes.
    //
    const XMLCh* const treeNodeKey = ::xsd::cxx::tree::user_data_keys::node;
#endif
  }
}

// Forward declarations.
//
namespace digidoc
{
  namespace manifest_1_2
  {
    class Base64Binary;
    class NamespacedToken;
    class NonNegativeInteger;
    class String;
    class AnyURI;
    class Manifest;
    class Version;
    class File_entry;
    class Preferred_view_mode;
    class Encryption_data;
    class Checksum_type;
    class Algorithm;
    class Algorithm_name;
    class Key_derivation;
    class Key_derivation_name;
    class Start_key_generation;
    class Start_key_generation_name;
    class Preferred_view_mode_member;
    class Preferred_view_mode_member1;
    class Preferred_view_mode_member2;
    class Checksum_type_member;
    class Algorithm_name_member;
    class Key_derivation_name_member;
    class Start_key_generation_name_member;
  }
}


#include <memory>    // ::std::unique_ptr
#include <limits>    // std::numeric_limits
#include <algorithm> // std::binary_search
#include <utility>   // std::move

#include <xsd/cxx/xml/char-utf8.hxx>

#include <xsd/cxx/tree/exceptions.hxx>
#include <xsd/cxx/tree/elements.hxx>
#include <xsd/cxx/tree/containers.hxx>
#include <xsd/cxx/tree/list.hxx>

#include <xsd/cxx/xml/dom/parsing-header.hxx>

namespace digidoc
{
  namespace manifest_1_2
  {
    class Base64Binary: public ::xml_schema::Base64Binary
    {
      public:
      // Constructors.
      //
      Base64Binary ();

      Base64Binary (const ::xml_schema::Base64Binary&);

      Base64Binary (const ::xercesc::DOMElement& e,
                    ::xml_schema::Flags f = 0,
                    ::xml_schema::Container* c = 0);

      Base64Binary (const ::xercesc::DOMAttr& a,
                    ::xml_schema::Flags f = 0,
                    ::xml_schema::Container* c = 0);

      Base64Binary (const ::std::string& s,
                    const ::xercesc::DOMElement* e,
                    ::xml_schema::Flags f = 0,
                    ::xml_schema::Container* c = 0);

      Base64Binary (const Base64Binary& x,
                    ::xml_schema::Flags f = 0,
                    ::xml_schema::Container* c = 0);

      virtual Base64Binary*
      _clone (::xml_schema::Flags f = 0,
              ::xml_schema::Container* c = 0) const;

      virtual 
      ~Base64Binary ();
    };

    class NamespacedToken: public ::xml_schema::Qname
    {
      public:
      // Constructors.
      //
      NamespacedToken (const ::xml_schema::Qname&);

      NamespacedToken (const ::xercesc::DOMElement& e,
                       ::xml_schema::Flags f = 0,
                       ::xml_schema::Container* c = 0);

      NamespacedToken (const ::xercesc::DOMAttr& a,
                       ::xml_schema::Flags f = 0,
                       ::xml_schema::Container* c = 0);

      NamespacedToken (const ::std::string& s,
                       const ::xercesc::DOMElement* e,
                       ::xml_schema::Flags f = 0,
                       ::xml_schema::Container* c = 0);

      NamespacedToken (const NamespacedToken& x,
                       ::xml_schema::Flags f = 0,
                       ::xml_schema::Container* c = 0);

      virtual NamespacedToken*
      _clone (::xml_schema::Flags f = 0,
              ::xml_schema::Container* c = 0) const;

      virtual 
      ~NamespacedToken ();
    };

    class NonNegativeInteger: public ::xsd::cxx::tree::fundamental_base< ::xml_schema::NonNegativeInteger, char, ::xml_schema::SimpleType >
    {
      public:
      // Constructors.
      //
      NonNegativeInteger (const ::xml_schema::NonNegativeInteger&);

      NonNegativeInteger (const ::xercesc::DOMElement& e,
                          ::xml_schema::Flags f = 0,
                          ::xml_schema::Container* c = 0);

      NonNegativeInteger (const ::xercesc::DOMAttr& a,
                          ::xml_schema::Flags f = 0,
                          ::xml_schema::Container* c = 0);

      NonNegativeInteger (const ::std::string& s,
                          const ::xercesc::DOMElement* e,
                          ::xml_schema::Flags f = 0,
                          ::xml_schema::Container* c = 0);

      NonNegativeInteger (const NonNegativeInteger& x,
                          ::xml_schema::Flags f = 0,
                          ::xml_schema::Container* c = 0);

      virtual NonNegativeInteger*
      _clone (::xml_schema::Flags f = 0,
              ::xml_schema::Container* c = 0) const;

      virtual 
      ~NonNegativeInteger ();
    };

    class String: public ::xml_schema::String
    {
      public:
      // Constructors.
      //
      String ();

      String (const char*);

      String (const ::std::string&);

      String (const ::xml_schema::String&);

      String (const ::xercesc::DOMElement& e,
              ::xml_schema::Flags f = 0,
              ::xml_schema::Container* c = 0);

      String (const ::xercesc::DOMAttr& a,
              ::xml_schema::Flags f = 0,
              ::xml_schema::Container* c = 0);

      String (const ::std::string& s,
              const ::xercesc::DOMElement* e,
              ::xml_schema::Flags f = 0,
              ::xml_schema::Container* c = 0);

      String (const String& x,
              ::xml_schema::Flags f = 0,
              ::xml_schema::Container* c = 0);

      virtual String*
      _clone (::xml_schema::Flags f = 0,
              ::xml_schema::Container* c = 0) const;

      virtual 
      ~String ();
    };

    class AnyURI: public ::xml_schema::Uri
    {
      public:
      // Constructors.
      //
      AnyURI (const ::xml_schema::Uri&);

      AnyURI (const ::xercesc::DOMElement& e,
              ::xml_schema::Flags f = 0,
              ::xml_schema::Container* c = 0);

      AnyURI (const ::xercesc::DOMAttr& a,
              ::xml_schema::Flags f = 0,
              ::xml_schema::Container* c = 0);

      AnyURI (const ::std::string& s,
              const ::xercesc::DOMElement* e,
              ::xml_schema::Flags f = 0,
              ::xml_schema::Container* c = 0);

      AnyURI (const AnyURI& x,
              ::xml_schema::Flags f = 0,
              ::xml_schema::Container* c = 0);

      virtual AnyURI*
      _clone (::xml_schema::Flags f = 0,
              ::xml_schema::Container* c = 0) const;

      virtual 
      ~AnyURI ();
    };

    class Manifest: public ::xml_schema::Type
    {
      public:
      // file-entry
      //
      typedef ::digidoc::manifest_1_2::File_entry File_entryType;
      typedef ::xsd::cxx::tree::sequence< File_entryType > File_entrySequence;
      typedef File_entrySequence::iterator File_entryIterator;
      typedef File_entrySequence::const_iterator File_entryConstIterator;
      typedef ::xsd::cxx::tree::traits< File_entryType, char > File_entryTraits;

      const File_entrySequence&
      file_entry () const;

      File_entrySequence&
      file_entry ();

      void
      file_entry (const File_entrySequence& s);

      // version
      //
      typedef ::digidoc::manifest_1_2::Version VersionType;
      typedef ::xsd::cxx::tree::traits< VersionType, char > VersionTraits;

      const VersionType&
      version () const;

      VersionType&
      version ();

      void
      version (const VersionType& x);

      void
      version (::std::unique_ptr< VersionType > p);

      // Constructors.
      //
      Manifest (const VersionType&);

      Manifest (const ::xercesc::DOMElement& e,
                ::xml_schema::Flags f = 0,
                ::xml_schema::Container* c = 0);

      Manifest (const Manifest& x,
                ::xml_schema::Flags f = 0,
                ::xml_schema::Container* c = 0);

      virtual Manifest*
      _clone (::xml_schema::Flags f = 0,
              ::xml_schema::Container* c = 0) const;

      private:
      Manifest&
      operator= (const Manifest& x);

      public:
      virtual 
      ~Manifest ();

      // Implementation.
      //
      protected:
      void
      parse (::xsd::cxx::xml::dom::parser< char >&,
             ::xml_schema::Flags);

      protected:
      File_entrySequence file_entry_;
      ::xsd::cxx::tree::one< VersionType > version_;
    };

    class Version: public ::xml_schema::Token
    {
      public:
      enum Value
      {
        cxx_1_2
      };

      Version (Value v);

      Version (const char* v);

      Version (const ::std::string& v);

      Version (const ::xml_schema::Token& v);

      Version (const ::xercesc::DOMElement& e,
               ::xml_schema::Flags f = 0,
               ::xml_schema::Container* c = 0);

      Version (const ::xercesc::DOMAttr& a,
               ::xml_schema::Flags f = 0,
               ::xml_schema::Container* c = 0);

      Version (const ::std::string& s,
               const ::xercesc::DOMElement* e,
               ::xml_schema::Flags f = 0,
               ::xml_schema::Container* c = 0);

      Version (const Version& x,
               ::xml_schema::Flags f = 0,
               ::xml_schema::Container* c = 0);

      virtual Version*
      _clone (::xml_schema::Flags f = 0,
              ::xml_schema::Container* c = 0) const;

      Version&
      operator= (Value v);

      virtual
      operator Value () const
      {
        return _xsd_Version_convert ();
      }

      protected:
      Value
      _xsd_Version_convert () const;

      public:
      static const char* const _xsd_Version_literals_[1];
      static const Value _xsd_Version_indexes_[1];
    };

    class File_entry: public ::xml_schema::Type
    {
      public:
      // encryption-data
      //
      typedef ::digidoc::manifest_1_2::Encryption_data Encryption_dataType;
      typedef ::xsd::cxx::tree::optional< Encryption_dataType > Encryption_dataOptional;
      typedef ::xsd::cxx::tree::traits< Encryption_dataType, char > Encryption_dataTraits;

      const Encryption_dataOptional&
      encryption_data () const;

      Encryption_dataOptional&
      encryption_data ();

      void
      encryption_data (const Encryption_dataType& x);

      void
      encryption_data (const Encryption_dataOptional& x);

      void
      encryption_data (::std::unique_ptr< Encryption_dataType > p);

      // full-path
      //
      typedef ::digidoc::manifest_1_2::String Full_pathType;
      typedef ::xsd::cxx::tree::traits< Full_pathType, char > Full_pathTraits;

      const Full_pathType&
      full_path () const;

      Full_pathType&
      full_path ();

      void
      full_path (const Full_pathType& x);

      void
      full_path (::std::unique_ptr< Full_pathType > p);

      // size
      //
      typedef ::digidoc::manifest_1_2::NonNegativeInteger SizeType;
      typedef ::xsd::cxx::tree::optional< SizeType > SizeOptional;
      typedef ::xsd::cxx::tree::traits< SizeType, char > SizeTraits;

      const SizeOptional&
      size () const;

      SizeOptional&
      size ();

      void
      size (const SizeType& x);

      void
      size (const SizeOptional& x);

      void
      size (::std::unique_ptr< SizeType > p);

      // media-type
      //
      typedef ::digidoc::manifest_1_2::String Media_typeType;
      typedef ::xsd::cxx::tree::traits< Media_typeType, char > Media_typeTraits;

      const Media_typeType&
      media_type () const;

      Media_typeType&
      media_type ();

      void
      media_type (const Media_typeType& x);

      void
      media_type (::std::unique_ptr< Media_typeType > p);

      // preferred-view-mode
      //
      typedef ::digidoc::manifest_1_2::Preferred_view_mode Preferred_view_modeType;
      typedef ::xsd::cxx::tree::optional< Preferred_view_modeType > Preferred_view_modeOptional;
      typedef ::xsd::cxx::tree::traits< Preferred_view_modeType, char > Preferred_view_modeTraits;

      const Preferred_view_modeOptional&
      preferred_view_mode () const;

      Preferred_view_modeOptional&
      preferred_view_mode ();

      void
      preferred_view_mode (const Preferred_view_modeType& x);

      void
      preferred_view_mode (const Preferred_view_modeOptional& x);

      void
      preferred_view_mode (::std::unique_ptr< Preferred_view_modeType > p);

      // version
      //
      typedef ::digidoc::manifest_1_2::String VersionType;
      typedef ::xsd::cxx::tree::optional< VersionType > VersionOptional;
      typedef ::xsd::cxx::tree::traits< VersionType, char > VersionTraits;

      const VersionOptional&
      version () const;

      VersionOptional&
      version ();

      void
      version (const VersionType& x);

      void
      version (const VersionOptional& x);

      void
      version (::std::unique_ptr< VersionType > p);

      // Constructors.
      //
      File_entry (const Full_pathType&,
                  const Media_typeType&);

      File_entry (const ::xercesc::DOMElement& e,
                  ::xml_schema::Flags f = 0,
                  ::xml_schema::Container* c = 0);

      File_entry (const File_entry& x,
                  ::xml_schema::Flags f = 0,
                  ::xml_schema::Container* c = 0);

      virtual File_entry*
      _clone (::xml_schema::Flags f = 0,
              ::xml_schema::Container* c = 0) const;

      private:
      File_entry&
      operator= (const File_entry& x);

      public:
      virtual 
      ~File_entry ();

      // Implementation.
      //
      protected:
      void
      parse (::xsd::cxx::xml::dom::parser< char >&,
             ::xml_schema::Flags);

      protected:
      Encryption_dataOptional encryption_data_;
      ::xsd::cxx::tree::one< Full_pathType > full_path_;
      SizeOptional size_;
      ::xsd::cxx::tree::one< Media_typeType > media_type_;
      Preferred_view_modeOptional preferred_view_mode_;
      VersionOptional version_;
    };

    class Preferred_view_mode: public ::xml_schema::String
    {
      public:

      Preferred_view_mode (const char* v);

      Preferred_view_mode (const ::std::string& v);

      Preferred_view_mode (const ::xercesc::DOMElement& e,
                           ::xml_schema::Flags f = 0,
                           ::xml_schema::Container* c = 0);

      Preferred_view_mode (const ::xercesc::DOMAttr& a,
                           ::xml_schema::Flags f = 0,
                           ::xml_schema::Container* c = 0);

      Preferred_view_mode (const ::std::string& s,
                           const ::xercesc::DOMElement* e,
                           ::xml_schema::Flags f = 0,
                           ::xml_schema::Container* c = 0);

      Preferred_view_mode (const Preferred_view_mode& x,
                           ::xml_schema::Flags f = 0,
                           ::xml_schema::Container* c = 0);

      virtual Preferred_view_mode*
      _clone (::xml_schema::Flags f = 0,
              ::xml_schema::Container* c = 0) const;
    };

    class Encryption_data: public ::xml_schema::Type
    {
      public:
      // algorithm
      //
      typedef ::digidoc::manifest_1_2::Algorithm AlgorithmType;
      typedef ::xsd::cxx::tree::traits< AlgorithmType, char > AlgorithmTraits;

      const AlgorithmType&
      algorithm () const;

      AlgorithmType&
      algorithm ();

      void
      algorithm (const AlgorithmType& x);

      void
      algorithm (::std::unique_ptr< AlgorithmType > p);

      // start-key-generation
      //
      typedef ::digidoc::manifest_1_2::Start_key_generation Start_key_generationType;
      typedef ::xsd::cxx::tree::optional< Start_key_generationType > Start_key_generationOptional;
      typedef ::xsd::cxx::tree::traits< Start_key_generationType, char > Start_key_generationTraits;

      const Start_key_generationOptional&
      start_key_generation () const;

      Start_key_generationOptional&
      start_key_generation ();

      void
      start_key_generation (const Start_key_generationType& x);

      void
      start_key_generation (const Start_key_generationOptional& x);

      void
      start_key_generation (::std::unique_ptr< Start_key_generationType > p);

      // key-derivation
      //
      typedef ::digidoc::manifest_1_2::Key_derivation Key_derivationType;
      typedef ::xsd::cxx::tree::traits< Key_derivationType, char > Key_derivationTraits;

      const Key_derivationType&
      key_derivation () const;

      Key_derivationType&
      key_derivation ();

      void
      key_derivation (const Key_derivationType& x);

      void
      key_derivation (::std::unique_ptr< Key_derivationType > p);

      // checksum-type
      //
      typedef ::digidoc::manifest_1_2::Checksum_type Checksum_typeType;
      typedef ::xsd::cxx::tree::traits< Checksum_typeType, char > Checksum_typeTraits;

      const Checksum_typeType&
      checksum_type () const;

      Checksum_typeType&
      checksum_type ();

      void
      checksum_type (const Checksum_typeType& x);

      void
      checksum_type (::std::unique_ptr< Checksum_typeType > p);

      // checksum
      //
      typedef ::digidoc::manifest_1_2::Base64Binary ChecksumType;
      typedef ::xsd::cxx::tree::traits< ChecksumType, char > ChecksumTraits;

      const ChecksumType&
      checksum () const;

      ChecksumType&
      checksum ();

      void
      checksum (const ChecksumType& x);

      void
      checksum (::std::unique_ptr< ChecksumType > p);

      // Constructors.
      //
      Encryption_data (const AlgorithmType&,
                       const Key_derivationType&,
                       const Checksum_typeType&,
                       const ChecksumType&);

      Encryption_data (::std::unique_ptr< AlgorithmType >,
                       ::std::unique_ptr< Key_derivationType >,
                       const Checksum_typeType&,
                       const ChecksumType&);

      Encryption_data (const ::xercesc::DOMElement& e,
                       ::xml_schema::Flags f = 0,
                       ::xml_schema::Container* c = 0);

      Encryption_data (const Encryption_data& x,
                       ::xml_schema::Flags f = 0,
                       ::xml_schema::Container* c = 0);

      virtual Encryption_data*
      _clone (::xml_schema::Flags f = 0,
              ::xml_schema::Container* c = 0) const;

      private:
      Encryption_data&
      operator= (const Encryption_data& x);

      public:
      virtual 
      ~Encryption_data ();

      // Implementation.
      //
      protected:
      void
      parse (::xsd::cxx::xml::dom::parser< char >&,
             ::xml_schema::Flags);

      protected:
      ::xsd::cxx::tree::one< AlgorithmType > algorithm_;
      Start_key_generationOptional start_key_generation_;
      ::xsd::cxx::tree::one< Key_derivationType > key_derivation_;
      ::xsd::cxx::tree::one< Checksum_typeType > checksum_type_;
      ::xsd::cxx::tree::one< ChecksumType > checksum_;
    };

    class Checksum_type: public ::xml_schema::String
    {
      public:

      Checksum_type (const char* v);

      Checksum_type (const ::std::string& v);

      Checksum_type (const ::xercesc::DOMElement& e,
                     ::xml_schema::Flags f = 0,
                     ::xml_schema::Container* c = 0);

      Checksum_type (const ::xercesc::DOMAttr& a,
                     ::xml_schema::Flags f = 0,
                     ::xml_schema::Container* c = 0);

      Checksum_type (const ::std::string& s,
                     const ::xercesc::DOMElement* e,
                     ::xml_schema::Flags f = 0,
                     ::xml_schema::Container* c = 0);

      Checksum_type (const Checksum_type& x,
                     ::xml_schema::Flags f = 0,
                     ::xml_schema::Container* c = 0);

      virtual Checksum_type*
      _clone (::xml_schema::Flags f = 0,
              ::xml_schema::Container* c = 0) const;
    };

    class Algorithm: public ::xml_schema::Type
    {
      public:
      // algorithm-name
      //
      typedef ::digidoc::manifest_1_2::Algorithm_name Algorithm_nameType;
      typedef ::xsd::cxx::tree::traits< Algorithm_nameType, char > Algorithm_nameTraits;

      const Algorithm_nameType&
      algorithm_name () const;

      Algorithm_nameType&
      algorithm_name ();

      void
      algorithm_name (const Algorithm_nameType& x);

      void
      algorithm_name (::std::unique_ptr< Algorithm_nameType > p);

      // initialisation-vector
      //
      typedef ::digidoc::manifest_1_2::Base64Binary Initialisation_vectorType;
      typedef ::xsd::cxx::tree::traits< Initialisation_vectorType, char > Initialisation_vectorTraits;

      const Initialisation_vectorType&
      initialisation_vector () const;

      Initialisation_vectorType&
      initialisation_vector ();

      void
      initialisation_vector (const Initialisation_vectorType& x);

      void
      initialisation_vector (::std::unique_ptr< Initialisation_vectorType > p);

      // Constructors.
      //
      Algorithm (const Algorithm_nameType&,
                 const Initialisation_vectorType&);

      Algorithm (const ::xercesc::DOMElement& e,
                 ::xml_schema::Flags f = 0,
                 ::xml_schema::Container* c = 0);

      Algorithm (const Algorithm& x,
                 ::xml_schema::Flags f = 0,
                 ::xml_schema::Container* c = 0);

      virtual Algorithm*
      _clone (::xml_schema::Flags f = 0,
              ::xml_schema::Container* c = 0) const;

      private:
      Algorithm&
      operator= (const Algorithm& x);

      public:
      virtual 
      ~Algorithm ();

      // Implementation.
      //
      protected:
      void
      parse (::xsd::cxx::xml::dom::parser< char >&,
             ::xml_schema::Flags);

      protected:
      ::xsd::cxx::tree::one< Algorithm_nameType > algorithm_name_;
      ::xsd::cxx::tree::one< Initialisation_vectorType > initialisation_vector_;
    };

    class Algorithm_name: public ::xml_schema::String
    {
      public:

      Algorithm_name (const char* v);

      Algorithm_name (const ::std::string& v);

      Algorithm_name (const ::xercesc::DOMElement& e,
                      ::xml_schema::Flags f = 0,
                      ::xml_schema::Container* c = 0);

      Algorithm_name (const ::xercesc::DOMAttr& a,
                      ::xml_schema::Flags f = 0,
                      ::xml_schema::Container* c = 0);

      Algorithm_name (const ::std::string& s,
                      const ::xercesc::DOMElement* e,
                      ::xml_schema::Flags f = 0,
                      ::xml_schema::Container* c = 0);

      Algorithm_name (const Algorithm_name& x,
                      ::xml_schema::Flags f = 0,
                      ::xml_schema::Container* c = 0);

      virtual Algorithm_name*
      _clone (::xml_schema::Flags f = 0,
              ::xml_schema::Container* c = 0) const;
    };

    class Key_derivation: public ::xml_schema::Type
    {
      public:
      // key-derivation-name
      //
      typedef ::digidoc::manifest_1_2::Key_derivation_name Key_derivation_nameType;
      typedef ::xsd::cxx::tree::traits< Key_derivation_nameType, char > Key_derivation_nameTraits;

      const Key_derivation_nameType&
      key_derivation_name () const;

      Key_derivation_nameType&
      key_derivation_name ();

      void
      key_derivation_name (const Key_derivation_nameType& x);

      void
      key_derivation_name (::std::unique_ptr< Key_derivation_nameType > p);

      // salt
      //
      typedef ::digidoc::manifest_1_2::Base64Binary SaltType;
      typedef ::xsd::cxx::tree::traits< SaltType, char > SaltTraits;

      const SaltType&
      salt () const;

      SaltType&
      salt ();

      void
      salt (const SaltType& x);

      void
      salt (::std::unique_ptr< SaltType > p);

      // iteration-count
      //
      typedef ::digidoc::manifest_1_2::NonNegativeInteger Iteration_countType;
      typedef ::xsd::cxx::tree::traits< Iteration_countType, char > Iteration_countTraits;

      const Iteration_countType&
      iteration_count () const;

      Iteration_countType&
      iteration_count ();

      void
      iteration_count (const Iteration_countType& x);

      void
      iteration_count (::std::unique_ptr< Iteration_countType > p);

      // key-size
      //
      typedef ::digidoc::manifest_1_2::NonNegativeInteger Key_sizeType;
      typedef ::xsd::cxx::tree::optional< Key_sizeType > Key_sizeOptional;
      typedef ::xsd::cxx::tree::traits< Key_sizeType, char > Key_sizeTraits;

      const Key_sizeOptional&
      key_size () const;

      Key_sizeOptional&
      key_size ();

      void
      key_size (const Key_sizeType& x);

      void
      key_size (const Key_sizeOptional& x);

      void
      key_size (::std::unique_ptr< Key_sizeType > p);

      // Constructors.
      //
      Key_derivation (const Key_derivation_nameType&,
                      const SaltType&,
                      const Iteration_countType&);

      Key_derivation (const ::xercesc::DOMElement& e,
                      ::xml_schema::Flags f = 0,
                      ::xml_schema::Container* c = 0);

      Key_derivation (const Key_derivation& x,
                      ::xml_schema::Flags f = 0,
                      ::xml_schema::Container* c = 0);

      virtual Key_derivation*
      _clone (::xml_schema::Flags f = 0,
              ::xml_schema::Container* c = 0) const;

      private:
      Key_derivation&
      operator= (const Key_derivation& x);

      public:
      virtual 
      ~Key_derivation ();

      // Implementation.
      //
      protected:
      void
      parse (::xsd::cxx::xml::dom::parser< char >&,
             ::xml_schema::Flags);

      protected:
      ::xsd::cxx::tree::one< Key_derivation_nameType > key_derivation_name_;
      ::xsd::cxx::tree::one< SaltType > salt_;
      ::xsd::cxx::tree::one< Iteration_countType > iteration_count_;
      Key_sizeOptional key_size_;
    };

    class Key_derivation_name: public ::xml_schema::String
    {
      public:

      Key_derivation_name (const char* v);

      Key_derivation_name (const ::std::string& v);

      Key_derivation_name (const ::xercesc::DOMElement& e,
                           ::xml_schema::Flags f = 0,
                           ::xml_schema::Container* c = 0);

      Key_derivation_name (const ::xercesc::DOMAttr& a,
                           ::xml_schema::Flags f = 0,
                           ::xml_schema::Container* c = 0);

      Key_derivation_name (const ::std::string& s,
                           const ::xercesc::DOMElement* e,
                           ::xml_schema::Flags f = 0,
                           ::xml_schema::Container* c = 0);

      Key_derivation_name (const Key_derivation_name& x,
                           ::xml_schema::Flags f = 0,
                           ::xml_schema::Container* c = 0);

      virtual Key_derivation_name*
      _clone (::xml_schema::Flags f = 0,
              ::xml_schema::Container* c = 0) const;
    };

    class Start_key_generation: public ::xml_schema::Type
    {
      public:
      // start-key-generation-name
      //
      typedef ::digidoc::manifest_1_2::Start_key_generation_name Start_key_generation_nameType;
      typedef ::xsd::cxx::tree::traits< Start_key_generation_nameType, char > Start_key_generation_nameTraits;

      const Start_key_generation_nameType&
      start_key_generation_name () const;

      Start_key_generation_nameType&
      start_key_generation_name ();

      void
      start_key_generation_name (const Start_key_generation_nameType& x);

      void
      start_key_generation_name (::std::unique_ptr< Start_key_generation_nameType > p);

      // key-size
      //
      typedef ::digidoc::manifest_1_2::NonNegativeInteger Key_sizeType;
      typedef ::xsd::cxx::tree::optional< Key_sizeType > Key_sizeOptional;
      typedef ::xsd::cxx::tree::traits< Key_sizeType, char > Key_sizeTraits;

      const Key_sizeOptional&
      key_size () const;

      Key_sizeOptional&
      key_size ();

      void
      key_size (const Key_sizeType& x);

      void
      key_size (const Key_sizeOptional& x);

      void
      key_size (::std::unique_ptr< Key_sizeType > p);

      // Constructors.
      //
      Start_key_generation (const Start_key_generation_nameType&);

      Start_key_generation (const ::xercesc::DOMElement& e,
                            ::xml_schema::Flags f = 0,
                            ::xml_schema::Container* c = 0);

      Start_key_generation (const Start_key_generation& x,
                            ::xml_schema::Flags f = 0,
                            ::xml_schema::Container* c = 0);

      virtual Start_key_generation*
      _clone (::xml_schema::Flags f = 0,
              ::xml_schema::Container* c = 0) const;

      private:
      Start_key_generation&
      operator= (const Start_key_generation& x);

      public:
      virtual 
      ~Start_key_generation ();

      // Implementation.
      //
      protected:
      void
      parse (::xsd::cxx::xml::dom::parser< char >&,
             ::xml_schema::Flags);

      protected:
      ::xsd::cxx::tree::one< Start_key_generation_nameType > start_key_generation_name_;
      Key_sizeOptional key_size_;
    };

    class Start_key_generation_name: public ::xml_schema::String
    {
      public:

      Start_key_generation_name (const char* v);

      Start_key_generation_name (const ::std::string& v);

      Start_key_generation_name (const ::xercesc::DOMElement& e,
                                 ::xml_schema::Flags f = 0,
                                 ::xml_schema::Container* c = 0);

      Start_key_generation_name (const ::xercesc::DOMAttr& a,
                                 ::xml_schema::Flags f = 0,
                                 ::xml_schema::Container* c = 0);

      Start_key_generation_name (const ::std::string& s,
                                 const ::xercesc::DOMElement* e,
                                 ::xml_schema::Flags f = 0,
                                 ::xml_schema::Container* c = 0);

      Start_key_generation_name (const Start_key_generation_name& x,
                                 ::xml_schema::Flags f = 0,
                                 ::xml_schema::Container* c = 0);

      virtual Start_key_generation_name*
      _clone (::xml_schema::Flags f = 0,
              ::xml_schema::Container* c = 0) const;
    };

    class Preferred_view_mode_member: public ::xml_schema::Token
    {
      public:
      enum Value
      {
        edit
      };

      Preferred_view_mode_member (Value v);

      Preferred_view_mode_member (const char* v);

      Preferred_view_mode_member (const ::std::string& v);

      Preferred_view_mode_member (const ::xml_schema::Token& v);

      Preferred_view_mode_member (const ::xercesc::DOMElement& e,
                                  ::xml_schema::Flags f = 0,
                                  ::xml_schema::Container* c = 0);

      Preferred_view_mode_member (const ::xercesc::DOMAttr& a,
                                  ::xml_schema::Flags f = 0,
                                  ::xml_schema::Container* c = 0);

      Preferred_view_mode_member (const ::std::string& s,
                                  const ::xercesc::DOMElement* e,
                                  ::xml_schema::Flags f = 0,
                                  ::xml_schema::Container* c = 0);

      Preferred_view_mode_member (const Preferred_view_mode_member& x,
                                  ::xml_schema::Flags f = 0,
                                  ::xml_schema::Container* c = 0);

      virtual Preferred_view_mode_member*
      _clone (::xml_schema::Flags f = 0,
              ::xml_schema::Container* c = 0) const;

      Preferred_view_mode_member&
      operator= (Value v);

      virtual
      operator Value () const
      {
        return _xsd_Preferred_view_mode_member_convert ();
      }

      protected:
      Value
      _xsd_Preferred_view_mode_member_convert () const;

      public:
      static const char* const _xsd_Preferred_view_mode_member_literals_[1];
      static const Value _xsd_Preferred_view_mode_member_indexes_[1];
    };

    class Preferred_view_mode_member1: public ::xml_schema::Token
    {
      public:
      enum Value
      {
        presentation_slide_show
      };

      Preferred_view_mode_member1 (Value v);

      Preferred_view_mode_member1 (const char* v);

      Preferred_view_mode_member1 (const ::std::string& v);

      Preferred_view_mode_member1 (const ::xml_schema::Token& v);

      Preferred_view_mode_member1 (const ::xercesc::DOMElement& e,
                                   ::xml_schema::Flags f = 0,
                                   ::xml_schema::Container* c = 0);

      Preferred_view_mode_member1 (const ::xercesc::DOMAttr& a,
                                   ::xml_schema::Flags f = 0,
                                   ::xml_schema::Container* c = 0);

      Preferred_view_mode_member1 (const ::std::string& s,
                                   const ::xercesc::DOMElement* e,
                                   ::xml_schema::Flags f = 0,
                                   ::xml_schema::Container* c = 0);

      Preferred_view_mode_member1 (const Preferred_view_mode_member1& x,
                                   ::xml_schema::Flags f = 0,
                                   ::xml_schema::Container* c = 0);

      virtual Preferred_view_mode_member1*
      _clone (::xml_schema::Flags f = 0,
              ::xml_schema::Container* c = 0) const;

      Preferred_view_mode_member1&
      operator= (Value v);

      virtual
      operator Value () const
      {
        return _xsd_Preferred_view_mode_member1_convert ();
      }

      protected:
      Value
      _xsd_Preferred_view_mode_member1_convert () const;

      public:
      static const char* const _xsd_Preferred_view_mode_member1_literals_[1];
      static const Value _xsd_Preferred_view_mode_member1_indexes_[1];
    };

    class Preferred_view_mode_member2: public ::xml_schema::Token
    {
      public:
      enum Value
      {
        read_only
      };

      Preferred_view_mode_member2 (Value v);

      Preferred_view_mode_member2 (const char* v);

      Preferred_view_mode_member2 (const ::std::string& v);

      Preferred_view_mode_member2 (const ::xml_schema::Token& v);

      Preferred_view_mode_member2 (const ::xercesc::DOMElement& e,
                                   ::xml_schema::Flags f = 0,
                                   ::xml_schema::Container* c = 0);

      Preferred_view_mode_member2 (const ::xercesc::DOMAttr& a,
                                   ::xml_schema::Flags f = 0,
                                   ::xml_schema::Container* c = 0);

      Preferred_view_mode_member2 (const ::std::string& s,
                                   const ::xercesc::DOMElement* e,
                                   ::xml_schema::Flags f = 0,
                                   ::xml_schema::Container* c = 0);

      Preferred_view_mode_member2 (const Preferred_view_mode_member2& x,
                                   ::xml_schema::Flags f = 0,
                                   ::xml_schema::Container* c = 0);

      virtual Preferred_view_mode_member2*
      _clone (::xml_schema::Flags f = 0,
              ::xml_schema::Container* c = 0) const;

      Preferred_view_mode_member2&
      operator= (Value v);

      virtual
      operator Value () const
      {
        return _xsd_Preferred_view_mode_member2_convert ();
      }

      protected:
      Value
      _xsd_Preferred_view_mode_member2_convert () const;

      public:
      static const char* const _xsd_Preferred_view_mode_member2_literals_[1];
      static const Value _xsd_Preferred_view_mode_member2_indexes_[1];
    };

    class Checksum_type_member: public ::xml_schema::Token
    {
      public:
      enum Value
      {
        SHA1_1K
      };

      Checksum_type_member (Value v);

      Checksum_type_member (const char* v);

      Checksum_type_member (const ::std::string& v);

      Checksum_type_member (const ::xml_schema::Token& v);

      Checksum_type_member (const ::xercesc::DOMElement& e,
                            ::xml_schema::Flags f = 0,
                            ::xml_schema::Container* c = 0);

      Checksum_type_member (const ::xercesc::DOMAttr& a,
                            ::xml_schema::Flags f = 0,
                            ::xml_schema::Container* c = 0);

      Checksum_type_member (const ::std::string& s,
                            const ::xercesc::DOMElement* e,
                            ::xml_schema::Flags f = 0,
                            ::xml_schema::Container* c = 0);

      Checksum_type_member (const Checksum_type_member& x,
                            ::xml_schema::Flags f = 0,
                            ::xml_schema::Container* c = 0);

      virtual Checksum_type_member*
      _clone (::xml_schema::Flags f = 0,
              ::xml_schema::Container* c = 0) const;

      Checksum_type_member&
      operator= (Value v);

      virtual
      operator Value () const
      {
        return _xsd_Checksum_type_member_convert ();
      }

      protected:
      Value
      _xsd_Checksum_type_member_convert () const;

      public:
      static const char* const _xsd_Checksum_type_member_literals_[1];
      static const Value _xsd_Checksum_type_member_indexes_[1];
    };

    class Algorithm_name_member: public ::xml_schema::Token
    {
      public:
      enum Value
      {
        Blowfish_CFB
      };

      Algorithm_name_member (Value v);

      Algorithm_name_member (const char* v);

      Algorithm_name_member (const ::std::string& v);

      Algorithm_name_member (const ::xml_schema::Token& v);

      Algorithm_name_member (const ::xercesc::DOMElement& e,
                             ::xml_schema::Flags f = 0,
                             ::xml_schema::Container* c = 0);

      Algorithm_name_member (const ::xercesc::DOMAttr& a,
                             ::xml_schema::Flags f = 0,
                             ::xml_schema::Container* c = 0);

      Algorithm_name_member (const ::std::string& s,
                             const ::xercesc::DOMElement* e,
                             ::xml_schema::Flags f = 0,
                             ::xml_schema::Container* c = 0);

      Algorithm_name_member (const Algorithm_name_member& x,
                             ::xml_schema::Flags f = 0,
                             ::xml_schema::Container* c = 0);

      virtual Algorithm_name_member*
      _clone (::xml_schema::Flags f = 0,
              ::xml_schema::Container* c = 0) const;

      Algorithm_name_member&
      operator= (Value v);

      virtual
      operator Value () const
      {
        return _xsd_Algorithm_name_member_convert ();
      }

      protected:
      Value
      _xsd_Algorithm_name_member_convert () const;

      public:
      static const char* const _xsd_Algorithm_name_member_literals_[1];
      static const Value _xsd_Algorithm_name_member_indexes_[1];
    };

    class Key_derivation_name_member: public ::xml_schema::Token
    {
      public:
      enum Value
      {
        PBKDF2
      };

      Key_derivation_name_member (Value v);

      Key_derivation_name_member (const char* v);

      Key_derivation_name_member (const ::std::string& v);

      Key_derivation_name_member (const ::xml_schema::Token& v);

      Key_derivation_name_member (const ::xercesc::DOMElement& e,
                                  ::xml_schema::Flags f = 0,
                                  ::xml_schema::Container* c = 0);

      Key_derivation_name_member (const ::xercesc::DOMAttr& a,
                                  ::xml_schema::Flags f = 0,
                                  ::xml_schema::Container* c = 0);

      Key_derivation_name_member (const ::std::string& s,
                                  const ::xercesc::DOMElement* e,
                                  ::xml_schema::Flags f = 0,
                                  ::xml_schema::Container* c = 0);

      Key_derivation_name_member (const Key_derivation_name_member& x,
                                  ::xml_schema::Flags f = 0,
                                  ::xml_schema::Container* c = 0);

      virtual Key_derivation_name_member*
      _clone (::xml_schema::Flags f = 0,
              ::xml_schema::Container* c = 0) const;

      Key_derivation_name_member&
      operator= (Value v);

      virtual
      operator Value () const
      {
        return _xsd_Key_derivation_name_member_convert ();
      }

      protected:
      Value
      _xsd_Key_derivation_name_member_convert () const;

      public:
      static const char* const _xsd_Key_derivation_name_member_literals_[1];
      static const Value _xsd_Key_derivation_name_member_indexes_[1];
    };

    class Start_key_generation_name_member: public ::xml_schema::Token
    {
      public:
      enum Value
      {
        SHA1
      };

      Start_key_generation_name_member (Value v);

      Start_key_generation_name_member (const char* v);

      Start_key_generation_name_member (const ::std::string& v);

      Start_key_generation_name_member (const ::xml_schema::Token& v);

      Start_key_generation_name_member (const ::xercesc::DOMElement& e,
                                        ::xml_schema::Flags f = 0,
                                        ::xml_schema::Container* c = 0);

      Start_key_generation_name_member (const ::xercesc::DOMAttr& a,
                                        ::xml_schema::Flags f = 0,
                                        ::xml_schema::Container* c = 0);

      Start_key_generation_name_member (const ::std::string& s,
                                        const ::xercesc::DOMElement* e,
                                        ::xml_schema::Flags f = 0,
                                        ::xml_schema::Container* c = 0);

      Start_key_generation_name_member (const Start_key_generation_name_member& x,
                                        ::xml_schema::Flags f = 0,
                                        ::xml_schema::Container* c = 0);

      virtual Start_key_generation_name_member*
      _clone (::xml_schema::Flags f = 0,
              ::xml_schema::Container* c = 0) const;

      Start_key_generation_name_member&
      operator= (Value v);

      virtual
      operator Value () const
      {
        return _xsd_Start_key_generation_name_member_convert ();
      }

      protected:
      Value
      _xsd_Start_key_generation_name_member_convert () const;

      public:
      static const char* const _xsd_Start_key_generation_name_member_literals_[1];
      static const Value _xsd_Start_key_generation_name_member_indexes_[1];
    };
  }
}

#include <iosfwd>

#include <xercesc/sax/InputSource.hpp>
#include <xercesc/dom/DOMDocument.hpp>
#include <xercesc/dom/DOMErrorHandler.hpp>

namespace digidoc
{
  namespace manifest_1_2
  {
    // Parse a URI or a local file.
    //

    ::std::unique_ptr< ::digidoc::manifest_1_2::Manifest >
    manifest (const ::std::string& uri,
              ::xml_schema::Flags f = 0,
              const ::xml_schema::Properties& p = ::xml_schema::Properties ());

    ::std::unique_ptr< ::digidoc::manifest_1_2::Manifest >
    manifest (const ::std::string& uri,
              ::xml_schema::ErrorHandler& eh,
              ::xml_schema::Flags f = 0,
              const ::xml_schema::Properties& p = ::xml_schema::Properties ());

    ::std::unique_ptr< ::digidoc::manifest_1_2::Manifest >
    manifest (const ::std::string& uri,
              ::xercesc::DOMErrorHandler& eh,
              ::xml_schema::Flags f = 0,
              const ::xml_schema::Properties& p = ::xml_schema::Properties ());

    // Parse std::istream.
    //

    ::std::unique_ptr< ::digidoc::manifest_1_2::Manifest >
    manifest (::std::istream& is,
              ::xml_schema::Flags f = 0,
              const ::xml_schema::Properties& p = ::xml_schema::Properties ());

    ::std::unique_ptr< ::digidoc::manifest_1_2::Manifest >
    manifest (::std::istream& is,
              ::xml_schema::ErrorHandler& eh,
              ::xml_schema::Flags f = 0,
              const ::xml_schema::Properties& p = ::xml_schema::Properties ());

    ::std::unique_ptr< ::digidoc::manifest_1_2::Manifest >
    manifest (::std::istream& is,
              ::xercesc::DOMErrorHandler& eh,
              ::xml_schema::Flags f = 0,
              const ::xml_schema::Properties& p = ::xml_schema::Properties ());

    ::std::unique_ptr< ::digidoc::manifest_1_2::Manifest >
    manifest (::std::istream& is,
              const ::std::string& id,
              ::xml_schema::Flags f = 0,
              const ::xml_schema::Properties& p = ::xml_schema::Properties ());

    ::std::unique_ptr< ::digidoc::manifest_1_2::Manifest >
    manifest (::std::istream& is,
              const ::std::string& id,
              ::xml_schema::ErrorHandler& eh,
              ::xml_schema::Flags f = 0,
              const ::xml_schema::Properties& p = ::xml_schema::Properties ());

    ::std::unique_ptr< ::digidoc::manifest_1_2::Manifest >
    manifest (::std::istream& is,
              const ::std::string& id,
              ::xercesc::DOMErrorHandler& eh,
              ::xml_schema::Flags f = 0,
              const ::xml_schema::Properties& p = ::xml_schema::Properties ());

    // Parse xercesc::InputSource.
    //

    ::std::unique_ptr< ::digidoc::manifest_1_2::Manifest >
    manifest (::xercesc::InputSource& is,
              ::xml_schema::Flags f = 0,
              const ::xml_schema::Properties& p = ::xml_schema::Properties ());

    ::std::unique_ptr< ::digidoc::manifest_1_2::Manifest >
    manifest (::xercesc::InputSource& is,
              ::xml_schema::ErrorHandler& eh,
              ::xml_schema::Flags f = 0,
              const ::xml_schema::Properties& p = ::xml_schema::Properties ());

    ::std::unique_ptr< ::digidoc::manifest_1_2::Manifest >
    manifest (::xercesc::InputSource& is,
              ::xercesc::DOMErrorHandler& eh,
              ::xml_schema::Flags f = 0,
              const ::xml_schema::Properties& p = ::xml_schema::Properties ());

    // Parse xercesc::DOMDocument.
    //

    ::std::unique_ptr< ::digidoc::manifest_1_2::Manifest >
    manifest (const ::xercesc::DOMDocument& d,
              ::xml_schema::Flags f = 0,
              const ::xml_schema::Properties& p = ::xml_schema::Properties ());

    ::std::unique_ptr< ::digidoc::manifest_1_2::Manifest >
    manifest (::xml_schema::dom::unique_ptr< ::xercesc::DOMDocument > d,
              ::xml_schema::Flags f = 0,
              const ::xml_schema::Properties& p = ::xml_schema::Properties ());
  }
}

#include <iosfwd>

#include <xercesc/dom/DOMDocument.hpp>
#include <xercesc/dom/DOMErrorHandler.hpp>
#include <xercesc/framework/XMLFormatter.hpp>

#include <xsd/cxx/xml/dom/auto-ptr.hxx>

namespace digidoc
{
  namespace manifest_1_2
  {
    // Serialize to std::ostream.
    //

    void
    manifest (::std::ostream& os,
              const ::digidoc::manifest_1_2::Manifest& x, 
              const ::xml_schema::NamespaceInfomap& m = ::xml_schema::NamespaceInfomap (),
              const ::std::string& e = "UTF-8",
              ::xml_schema::Flags f = 0);

    void
    manifest (::std::ostream& os,
              const ::digidoc::manifest_1_2::Manifest& x, 
              ::xml_schema::ErrorHandler& eh,
              const ::xml_schema::NamespaceInfomap& m = ::xml_schema::NamespaceInfomap (),
              const ::std::string& e = "UTF-8",
              ::xml_schema::Flags f = 0);

    void
    manifest (::std::ostream& os,
              const ::digidoc::manifest_1_2::Manifest& x, 
              ::xercesc::DOMErrorHandler& eh,
              const ::xml_schema::NamespaceInfomap& m = ::xml_schema::NamespaceInfomap (),
              const ::std::string& e = "UTF-8",
              ::xml_schema::Flags f = 0);

    // Serialize to xercesc::XMLFormatTarget.
    //

    void
    manifest (::xercesc::XMLFormatTarget& ft,
              const ::digidoc::manifest_1_2::Manifest& x, 
              const ::xml_schema::NamespaceInfomap& m = ::xml_schema::NamespaceInfomap (),
              const ::std::string& e = "UTF-8",
              ::xml_schema::Flags f = 0);

    void
    manifest (::xercesc::XMLFormatTarget& ft,
              const ::digidoc::manifest_1_2::Manifest& x, 
              ::xml_schema::ErrorHandler& eh,
              const ::xml_schema::NamespaceInfomap& m = ::xml_schema::NamespaceInfomap (),
              const ::std::string& e = "UTF-8",
              ::xml_schema::Flags f = 0);

    void
    manifest (::xercesc::XMLFormatTarget& ft,
              const ::digidoc::manifest_1_2::Manifest& x, 
              ::xercesc::DOMErrorHandler& eh,
              const ::xml_schema::NamespaceInfomap& m = ::xml_schema::NamespaceInfomap (),
              const ::std::string& e = "UTF-8",
              ::xml_schema::Flags f = 0);

    // Serialize to an existing xercesc::DOMDocument.
    //

    void
    manifest (::xercesc::DOMDocument& d,
              const ::digidoc::manifest_1_2::Manifest& x,
              ::xml_schema::Flags f = 0);

    // Serialize to a new xercesc::DOMDocument.
    //

    ::xml_schema::dom::unique_ptr< ::xercesc::DOMDocument >
    manifest (const ::digidoc::manifest_1_2::Manifest& x, 
              const ::xml_schema::NamespaceInfomap& m = ::xml_schema::NamespaceInfomap (),
              ::xml_schema::Flags f = 0);

    void
    operator<< (::xercesc::DOMElement&, const Base64Binary&);

    void
    operator<< (::xercesc::DOMAttr&, const Base64Binary&);

    void
    operator<< (::xml_schema::ListStream&,
                const Base64Binary&);

    void
    operator<< (::xercesc::DOMElement&, const NamespacedToken&);

    void
    operator<< (::xercesc::DOMAttr&, const NamespacedToken&);

    void
    operator<< (::xml_schema::ListStream&,
                const NamespacedToken&);

    void
    operator<< (::xercesc::DOMElement&, const NonNegativeInteger&);

    void
    operator<< (::xercesc::DOMAttr&, const NonNegativeInteger&);

    void
    operator<< (::xml_schema::ListStream&,
                const NonNegativeInteger&);

    void
    operator<< (::xercesc::DOMElement&, const String&);

    void
    operator<< (::xercesc::DOMAttr&, const String&);

    void
    operator<< (::xml_schema::ListStream&,
                const String&);

    void
    operator<< (::xercesc::DOMElement&, const AnyURI&);

    void
    operator<< (::xercesc::DOMAttr&, const AnyURI&);

    void
    operator<< (::xml_schema::ListStream&,
                const AnyURI&);

    void
    operator<< (::xercesc::DOMElement&, const Manifest&);

    void
    operator<< (::xercesc::DOMElement&, const Version&);

    void
    operator<< (::xercesc::DOMAttr&, const Version&);

    void
    operator<< (::xml_schema::ListStream&,
                const Version&);

    void
    operator<< (::xercesc::DOMElement&, const File_entry&);

    void
    operator<< (::xercesc::DOMElement&, const Preferred_view_mode&);

    void
    operator<< (::xercesc::DOMAttr&, const Preferred_view_mode&);

    void
    operator<< (::xml_schema::ListStream&,
                const Preferred_view_mode&);

    void
    operator<< (::xercesc::DOMElement&, const Encryption_data&);

    void
    operator<< (::xercesc::DOMElement&, const Checksum_type&);

    void
    operator<< (::xercesc::DOMAttr&, const Checksum_type&);

    void
    operator<< (::xml_schema::ListStream&,
                const Checksum_type&);

    void
    operator<< (::xercesc::DOMElement&, const Algorithm&);

    void
    operator<< (::xercesc::DOMElement&, const Algorithm_name&);

    void
    operator<< (::xercesc::DOMAttr&, const Algorithm_name&);

    void
    operator<< (::xml_schema::ListStream&,
                const Algorithm_name&);

    void
    operator<< (::xercesc::DOMElement&, const Key_derivation&);

    void
    operator<< (::xercesc::DOMElement&, const Key_derivation_name&);

    void
    operator<< (::xercesc::DOMAttr&, const Key_derivation_name&);

    void
    operator<< (::xml_schema::ListStream&,
                const Key_derivation_name&);

    void
    operator<< (::xercesc::DOMElement&, const Start_key_generation&);

    void
    operator<< (::xercesc::DOMElement&, const Start_key_generation_name&);

    void
    operator<< (::xercesc::DOMAttr&, const Start_key_generation_name&);

    void
    operator<< (::xml_schema::ListStream&,
                const Start_key_generation_name&);

    void
    operator<< (::xercesc::DOMElement&, const Preferred_view_mode_member&);

    void
    operator<< (::xercesc::DOMAttr&, const Preferred_view_mode_member&);

    void
    operator<< (::xml_schema::ListStream&,
                const Preferred_view_mode_member&);

    void
    operator<< (::xercesc::DOMElement&, const Preferred_view_mode_member1&);

    void
    operator<< (::xercesc::DOMAttr&, const Preferred_view_mode_member1&);

    void
    operator<< (::xml_schema::ListStream&,
                const Preferred_view_mode_member1&);

    void
    operator<< (::xercesc::DOMElement&, const Preferred_view_mode_member2&);

    void
    operator<< (::xercesc::DOMAttr&, const Preferred_view_mode_member2&);

    void
    operator<< (::xml_schema::ListStream&,
                const Preferred_view_mode_member2&);

    void
    operator<< (::xercesc::DOMElement&, const Checksum_type_member&);

    void
    operator<< (::xercesc::DOMAttr&, const Checksum_type_member&);

    void
    operator<< (::xml_schema::ListStream&,
                const Checksum_type_member&);

    void
    operator<< (::xercesc::DOMElement&, const Algorithm_name_member&);

    void
    operator<< (::xercesc::DOMAttr&, const Algorithm_name_member&);

    void
    operator<< (::xml_schema::ListStream&,
                const Algorithm_name_member&);

    void
    operator<< (::xercesc::DOMElement&, const Key_derivation_name_member&);

    void
    operator<< (::xercesc::DOMAttr&, const Key_derivation_name_member&);

    void
    operator<< (::xml_schema::ListStream&,
                const Key_derivation_name_member&);

    void
    operator<< (::xercesc::DOMElement&, const Start_key_generation_name_member&);

    void
    operator<< (::xercesc::DOMAttr&, const Start_key_generation_name_member&);

    void
    operator<< (::xml_schema::ListStream&,
                const Start_key_generation_name_member&);
  }
}

#include <xsd/cxx/post.hxx>

// Begin epilogue.
//
//
// End epilogue.

#endif // CXX_BUILDDIR_BUILD_BUILD_LIBDIGIDOCPP_3_16_0_ETC_SCHEMA_OPEN_DOCUMENT_MANIFEST_V1_2_HXX
